/*
	ProWesS, PROGS Windowing System

	PWHandleKeyPress

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 January 1995
*/

#include "private.h"
#include "PWHandler.h"

Error PWHandleKeyPress(PWSystem *system)
{
	PWKeyPress *keypress;
	char key=system->ptr_info.keystroke;

	if (key==0) return ERR_OK;
	system->ptr_info.keystroke=0;

	if (system->status&SSTATUS_XSCROLLABLE)
	{
		if (key==(char)199) 		/* left */
			return PWScrollScreen(system,-1,0,FALSE);
		if (key==(char)207) 		/* right */
			return PWScrollScreen(system,1,0,FALSE);
	}
	if (system->status&SSTATUS_YSCROLLABLE)
	{
		if (key==(char)215) 		/* up */
			return PWScrollScreen(system,0,-1,FALSE);
		if (key==(char)223) 		/* down */
			return PWScrollScreen(system,0,1,FALSE);
	}

	/* check for primary keypresses */
	for (keypress=system->keypresses; keypress; keypress=keypress->next)
	{
		if (keypress->key==key)
		{
			/* call handler routine */
			return keypress->owner->type->PWHandle(keypress->owner,0);
		}
	}

	/* check for secondary keypresses */
	for (keypress=system->keypresses; keypress; keypress=keypress->next)
	{
		if (keypress->alternative==key)
		{
			/* call handler routine */
			return keypress->owner->type->PWHandle(keypress->owner,0);
		}
	}

	/* no keypress object -> use catchkeys object if any */
	system->catch=key;
	if (system->catchkeys && system->catchkeys->type->PWHandle)
		return system->catchkeys->type->PWHandle(system->catchkeys,PW_EVENT_CATCH);

	return ERR_OK;
}
