/*
	ProWesS, PROGS Windowing System

	PWSkipTag : routine to get the position of the next tag in the taglist

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 January 1995
*/

#include "PWHandler_h"

int *PWSkipTag(int *taglist)
{
	if (*taglist&PW_TAGMASK_MULBIT)
		taglist+=PW_TAGINFO_SKIP(*taglist)+1;
	else if (*taglist&PW_TAGMASK_LIST)
	{
		/* skip parameter list */
		while (*taglist++!=NUL);
	}
	else if (*taglist&PW_TAGMASK_TAGLIST)
	{
		taglist++;
		/* skip list of tags */
		while (*taglist)
			taglist=PWSkipTag(taglist);
		taglist++;
	}
	else /* OOPS, UNRECOGNISED TAG -- THIS SHOULD NOT HAPPEN */
		/* I have to prevet an infinit loop here !! */
		taglist++;

	return taglist;
}
