/*
	ProWesS, PROGS Windowing System

	PWSleep - switch to dispay of sleeping prg in button frame

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 January 1995, completely reworked 15 July 1995
	26.10.1996 small adjustments necessary to make sure it works with
			   PWDetermineSize in a loop
	16.04.1997 no more keypresses
*/

#include <mem.h>
#include <win.h>
#include <job.h>
#include <thing.h>

#include "private.h"
#include "PWHandler.h"

/* forward declaration */
void SetSystem(PWRegion *region, PWSystem *system);

Error PWSleep(PWSystem *system)
{
	PWRegion *sleep=system->sleep;
	PWSystem currsys;
	Gstate gstate;
	Error err;

	if (sleep==NULL) return ERR_OK;

	err=PWClose(system);
	if (err) return err;
	system->status&=~(SSTATUS_BREAKDOWN|SSTATUS_SLEEP);

	/* keep system information so we can use the current system */
	MEMCopy(sizeof(PWSystem),system,&currsys);
	system->activated=FALSE;
	system->status|=SSTATUS_BUTFRAME|SSTATUS_WINCHANGE;
	system->regions=sleep;
	system->curr_xsiz=system->curr_ysiz=0;
	system->keypresses=NULL;

	err=PWActivate(sleep->owner);

	gstate=system->gstate;
	MEMCopy(sizeof(PWSystem),&currsys,system);
	system->gstate=gstate;
	system->status|=SSTATUS_WINCHANGE;

	return err;
}
