/*
	ProWesS, PROGS Windowing System

	dynamic configurator program for ProWesS

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 19 August 1995
*/

#include "mem_h"
#include "thing_h"

#include "ProWesS_h"

#define MAXLEN 100

static char info[]={"This is the ProWesS dynamic configuration\n"
					"program. If you edit a line, then the data\n"
					"entered, will be passed on to ProWesS for\n"
					"configuration. You can query whether a\n"
					"type is present by typing the (max 4 letter)\n"
					"type name preceded by a question mark and a\n"
					"space. If the type is not available, a beep\n"
					"will sound."};

Error config(PWObject object)
{
	char str[MAXLEN];
	Error err;

	PWChange(object,PW_EDLINE_GET,MAXLEN,str,NULL);

	err=THINGCall(PW_THING_NAME,PW_THING_CNFG,1,str);
	if (err) SMSBeep(2000,20);

	return ERR_OK;
}

void init()
{
	PWObject obj,it1,it2;

	PWCreate(NULL,&obj,PW_TYPE_OUTLINE,
				PW_OUTLINE_SLEEP,
				PW_OUTLINE_QUIT,
				PW_OUTLINE_QUIT_KEYPRESS, 27,
				PW_WINDOW_NOSCALE,
				NULL);
	PWCreate(obj,&it1,PW_TYPE_EDLINE,
				PW_EDLINE_MAXLENGTH, MAXLEN,
				PW_EDLINE_ACTION_AFTER,&config,
				NULL);
	PWCreate(obj,&it2,PW_TYPE_LABEL,
				PW_POSITION_ABOVE, it1,
				PW_SCALE_FACTOR, 0,
				PW_LABEL_TEXT, "enter configuration line",
				NULL);
	PWCreate(obj,NULL,PW_TYPE_INFOSTRING,
				PW_INFOSTRING_TEXT, info,
				PW_POSITION_ABOVE, it2,
				NULL);
	PWActivate(obj);
}
